package cpcns.dingZhi.ZTree.service.impl;

package .tmp;

import cpcns.dangAnBase.base.service.impl.DangAnBaseServiceImpl;
import cpcns.dingZhi.ZTree.dao.IZTreeDao;
import cpcns.dingZhi.ZTree.model.ZTreeNode;
import cpcns.dingZhi.ZTree.service.IZTreeService;
import cpcns.jhsks.xinxifenlei.xitongmokuai.zhuxinxishuweihu.model.ShouYeFenLei;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("zTreeServiceImpl")
public class ZTreeServiceImpl extends DangAnBaseServiceImpl<ShouYeFenLei> implements IZTreeService {
  @Autowired
  private IZTreeDao zTreeDaoImpl;
  
  public List<ZTreeNode> getZTreeNodes(HttpServletRequest request) {
    String leave = request.getParameter("leave");
    String pid = request.getParameter("pid");
    String type = request.getParameter("type");
    String roothbs = request.getParameter("roothbs");
    return ZTreeNdoes(pid, "", "", Boolean.valueOf(roothbs).booleanValue(), Boolean.valueOf(type).booleanValue());
  }
  
  private boolean isChildnodes(int hangbiaoshi) {
    boolean flage = false;
    String sql = "select t.hangbiaoshi from G_SHOUYEFENLEI t where t.fujiedianbiaoshi=:hangbiaoshi ";
    Map<String, Object> tp = new HashMap<>();
    tp.put("hangbiaoshi", Integer.valueOf(hangbiaoshi));
    System.out.println(hangbiaoshi);
    List list = this.zTreeDaoImpl.getList(sql, tp);
    if (list != null && list.size() > 0)
      flage = true; 
    return flage;
  }
  
  private List<ZTreeNode> ZTreeNdoes(String pid, String layer, String objCode, boolean roothbs, boolean type) {
    StringBuffer sql = new StringBuffer("select t.hangbiaoshi,t.jiluleixing,t.fujiedianbiaoshi,t.mingcheng,t.lianjiedizhi from G_SHOUYEFENLEI t where ");
    sql.append(" t.xianshi=:xianshi ");
    Map<String, Object> tp = new HashMap<>();
    if (roothbs) {
      sql.append(" and (t.hangbiaoshi=:hangbiaoshi or t.fujiedianbiaoshi=:fujiedianbiaoshi) ");
      tp.put("hangbiaoshi", pid);
    } else {
      sql.append(" and t.fujiedianbiaoshi=:fujiedianbiaoshi ");
    } 
    sql.append(" order by t.cixu ");
    tp.put("fujiedianbiaoshi", pid);
    tp.put("xianshi", "1");
    List<Object[]> list = this.zTreeDaoImpl.getList(sql.toString(), tp);
    List<ZTreeNode> treeNodes = new ArrayList<>();
    if (list != null && list.size() > 0) {
      for (int i = 0; i < list.size(); i++) {
        Object[] objs = list.get(i);
        Object hbs_ = objs[0];
        int hbs = Integer.parseInt(String.valueOf(hbs_));
        Object julx_ = objs[1];
        int julx = Integer.parseInt(String.valueOf(julx_));
        Object fjdbs_ = objs[2];
        int fjdbs = Integer.parseInt(String.valueOf(fjdbs_));
        String mc = (String)objs[3];
        String ljdz = (String)objs[4];
        boolean isParent = isChildnodes(hbs);
        String ml = "";
        String ml_ = "";
        if (StringUtils.isNotBlank(ljdz) && ljdz.indexOf("?") > 0) {
          ml = getTableAndMenLei(ljdz, "table", "menLei");
          ml_ = getStringByInfo(ljdz, "menLei");
        } 
        if (julx == 3) {
          ZTreeNode treeNode = new ZTreeNode(hbs, fjdbs, mc, true, isParent);
          if (type && ljdz != null && ljdz.indexOf("menLei=") > 0) {
            boolean result = isDongTaiJieDian(ml, "", "=");
            if (result) {
              treeNode.setParent(true);
              treeNode.setLayer(0);
            } 
          } 
          if (StringUtils.isNotBlank(ml_)) {
            treeNode.setObjCode(ml);
            treeNodes.add(treeNode);
          } 
        } else {
          ZTreeNode treeNode = new ZTreeNode(hbs, fjdbs, mc, true, isParent);
          if (StringUtils.isNotBlank(ml_)) {
            boolean result = isDongTaiJieDian(ml, "", "=");
            if (result) {
              treeNode.setParent(true);
              treeNode.setLayer(0);
            } 
          } 
          treeNode.setObjCode(ml);
          treeNodes.add(treeNode);
        } 
      } 
    } else if (StringUtils.isNotBlank(objCode)) {
      Object[] objs = getDongTaiJieDianByMenLeiAndPid(objCode, layer);
      Object obj = objs[0];
      int hbs = Integer.parseInt(String.valueOf(obj));
      int fjdbs = Integer.parseInt(String.valueOf(objs[4]));
      String mc = String.valueOf(objs[3]) + "[动态节点]";
      boolean isParent = isDongTaiJieDian(objCode, layer, ">");
      ZTreeNode treeNode = new ZTreeNode(hbs, fjdbs, mc, true, isParent);
      treeNode.setObjCode((String)objs[1]);
      int layer_ = Integer.parseInt(layer) + 1;
      treeNode.setLayer(layer_);
      treeNodes.add(treeNode);
    } 
    return treeNodes;
  }
  
  private boolean isDongTaiJieDian(String ml, String pid, String yunSuanFu) {
    boolean flage = false;
    StringBuffer sql = new StringBuffer("select * from D_DONGTAIJIEDIAN  where menlei='");
    sql.append(ml).append("'");
    if (StringUtils.isNotBlank(pid))
      sql.append(" and pid").append(yunSuanFu).append(pid); 
    List list = this.zTreeDaoImpl.getListToMap(sql.toString(), true);
    if (list != null && list.size() > 0)
      flage = true; 
    return flage;
  }
  
  private Object[] getDongTaiJieDianByMenLeiAndPid(String ml, String pid) {
    StringBuffer sql = new StringBuffer("select hangbiaoshi,menlei,filedmingcheng,filedlabel,pid from D_DONGTAIJIEDIAN  where menlei='");
    sql.append(ml).append("'");
    if (StringUtils.isNotBlank(pid))
      sql.append(" and pid=").append(pid); 
    List<Object[]> list = this.zTreeDaoImpl.getListToMap(sql.toString(), false);
    return list.get(0);
  }
  
  private String getStringByInfo(String str, String va) {
    String[] info = str.split(va);
    if (StringUtils.isNotBlank(str) && info.length > 1) {
      if (info[1].indexOf("&") > -1)
        return info[1].substring(1, info[1].indexOf("&")).toUpperCase(); 
      return info[1].substring(1, info[1].length()).toUpperCase();
    } 
    return "";
  }
  
  private static String getTableAndMenLei(String str, String table, String menLei) {
    StringBuffer tm = new StringBuffer();
    String[] info1 = str.split(table);
    System.out.println("====" + str);
    if (info1.length > 1) {
      tm.append(info1[1].substring(1, info1[1].indexOf("&")).toUpperCase());
      String[] info2 = str.split(menLei);
      if (info2.length > 1)
        if (info2[1].indexOf("&") > 0) {
          tm.append("_").append(info2[1].substring(1, info2[1].indexOf("&")).toUpperCase());
        } else {
          tm.append("_").append(info2[1].substring(1).toUpperCase());
        }  
    } 
    return tm.toString();
  }
  
  public List<ZTreeNode> asyncGetNodes(String id, String pid, String layer, String objCode, String type) {
    return ZTreeNdoes(id, layer, objCode, false, Boolean.valueOf(type).booleanValue());
  }
}
